;
; $Log:   C:/shell/vcs/crit.asv  $
; 
;    Rev 3.4   01 Oct 1986  9:25:26   kent
; Initial revision.
;
ifdef AZTEC86
codeseg	segment public 'CODE'
dataseg	segment public 'DATA'
extrn critical_:word
dataseg	ends
assume cs:codeseg,ds:dataseg
endif

ifdef MSC
_TEXT	segment byte public 'CODE'
_DATA	segment byte public 'DATA'
extrn _critical:word
_DATA	ends
	assume cs:_TEXT,ds:_DATA
endif

old_handler	label dword
old_off	dw ?
old_seg	dw ?
critical	equ 24H

ifdef AZTEC86
extrn	longjmp_:near
endif
ifdef MSC
extrn	_longjmp:near
endif

datasegment	dw	?
	public crit_handler
crit_handler proc near
	pushf
	call	dword ptr cs:old_handler
	cmp		al,2		; is this an abort?
	jne outahere
	mov	ax,-1
	push ax
	mov	ax,offset critical
	push	ax
	mov	ds,cs:datasegment		; address data segment
ifdef AZTEC86
	call longjmp_		; we're byebye
endif
ifdef MSC
	call _longjmp
endif
outahere:
	iret
crit_handler	endp

ifdef AZTEC86
	public setup_crit_
setup_crit_	proc	near
endif
ifdef MSC
	public _setup_crit
_setup_crit	proc	near
endif
	push	es
	push	ds
	push	si
	mov	cs:datasegment,ds
	xor	ax,ax				; address vectors
	mov	ds,ax
	mov	bx,critical*4		; offset of critical error handler
	les si,[bx]				; load into es:si
	mov	cs:old_off,si		; save off
	mov	cs:old_seg,es		;
	mov	word ptr [bx],offset crit_handler
	mov	2[bx],cs
	pop	si
	pop	ds
	pop	es
	ret
ifdef AZTEC86
setup_crit_	endp
endif
ifdef MSC
_setup_crit	endp
endif

ifdef AZTEC86
	public restore_crit_
restore_crit_	proc	near
endif
ifdef MSC
	public _restore_crit
_restore_crit	proc	near
endif
	push	es
	push	ds
	push	si
	xor	ax,ax
	mov	ds,ax
	les	si,cs:old_handler
	mov	bx,critical*4
	mov	[bx],si
	mov	2[bx],es
	pop	si
	pop	ds
	pop	es
	ret

ifdef AZTEC86
restore_crit_	endp
endif

ifdef MSC
_restore_crit	endp
endif

ifdef AZTEC86
codeseg	ends
endif

ifdef MSC
_TEXT	ends
endif
	end
	
